> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Add Shopper Profiles to Segment

POST https://api.bigcommerce.com/stores/{store_hash}/v3/segments/{segmentId}/shopper-profiles
Content-Type: application/json

Add *Shopper Profiles* to a specific *Segment*.

**Limits**
* Limit of *Shopper Profiles* per request is `50`.
* Limit of 10 concurrent requests.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/management/customer-segmentation/shopper-profiles-for-a-segment/post-shopper-profile

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Customers | modify | `store_v2_customers` | | Customers | read-only | `store_v2_customers_read_only` | **NOTE**: GET endpoints require only read-only permission, except for the [Get All Shopper Profiles in a Segment](/developer/api-reference/rest/admin/management/customer-segmentation/shopper-profiles-for-a-segment/get-segment-profiles) endpoint which requires modify permission. ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see [API Accounts and OAuth Scopes](/developer/docs/overview/api-fundamentals/api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see [API Accounts and OAuth Scopes](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `segmentId` (string, required) — The *Segment* ID.
- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

### Body (application/json)

This endpoint expects a list of string.

- `list of string`

## Response

### 201

An array of *Shopper Profiles* added to a *Segment*.

- `data` (list of ShopperProfile, optional)
- `errors` (list of ErrorResponse, optional) — Empty on success. Populated when one or more *Shopper Profiles* could not be added to the *Segment*.
- `meta` (BatchResultMeta, optional) — The number of items (total, successes, failures) in a batch request.

## Errors

### 409 Conflict Error

Conflict

- `data` (list of SegmentsSegmentIdShopperProfilesPostResponsesContentApplicationJsonSchemaDataItems, required)
- `errors` (list of SegmentsSegmentIdShopperProfilesPostResponsesContentApplicationJsonSchemaErrorsItems, required)
- `meta` (SegmentsSegmentIdShopperProfilesPostResponsesContentApplicationJsonSchemaMeta, required)

### 422 Unprocessable Entity Error

Unable to add some or all *Shopper Profiles* to the *Segment* due to invalid request data.

- `data` (list of ShopperProfile, optional)
- `errors` (list of ErrorResponse, optional) — Empty on success. Populated when one or more *Shopper Profiles* could not be added to the *Segment*.
- `meta` (BatchResultMeta, optional) — The number of items (total, successes, failures) in a batch request.

## Types

### ShopperProfile

- `id` (string, optional) — The ID of the *Shopper Profile*.
- `customer_id` (integer, optional) — The ID of the registered *Customer* associated with this *Shopper Profile*.
- `created_at` (datetime, optional) — The date and time when the *Shopper Profile* was created.
- `updated_at` (datetime, optional) — The date and time when the *Shopper Profile* was last updated.

### ErrorResponse

Error payload for the BigCommerce API.

- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional)
- `instance` (string, optional)
- `errors` (DetailedErrors, optional)

### BatchResultMeta

The number of items (total, successes, failures) in a batch request.

- `total` (integer, optional) — The number of items in the batch request.
- `success` (integer, optional) — The number of items that were processed successfully.
- `failed` (integer, optional) — The number of items that were not processed successfully.

### SegmentsSegmentIdShopperProfilesPostResponsesContentApplicationJsonSchemaDataItems

### SegmentsSegmentIdShopperProfilesPostResponsesContentApplicationJsonSchemaErrorsItems

- `status` (double, optional)
- `title` (string, optional)
- `type` (string, optional)
- `errors` (SegmentsSegmentIdShopperProfilesPostResponsesContentApplicationJsonSchemaErrorsItemsErrors, optional)

### SegmentsSegmentIdShopperProfilesPostResponsesContentApplicationJsonSchemaMeta

- `total` (double, required)
- `success` (double, required)
- `failed` (double, required)

### DetailedErrors

### SegmentsSegmentIdShopperProfilesPostResponsesContentApplicationJsonSchemaErrorsItemsErrors

- `0` (string, optional)

## Examples

**Request**

```json
[
  "string"
]
```

**Response**

```json
{
  "data": [
    {
      "id": "string",
      "customer_id": 1,
      "created_at": "2024-01-15T09:30:00Z",
      "updated_at": "2024-01-15T09:30:00Z"
    }
  ],
  "errors": [
    {
      "status": 1,
      "title": "string",
      "type": "string",
      "instance": "string",
      "errors": {}
    }
  ],
  "meta": {
    "total": 1,
    "success": 1,
    "failed": 0
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/segments/segmentId/shopper-profiles"

payload = ["string"]
headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/segments/segmentId/shopper-profiles';
const options = {
  method: 'POST',
  headers: {
    Accept: 'application/json',
    'X-Auth-Token': '<apiKey>',
    'Content-Type': 'application/json'
  },
  body: '["string"]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/segments/segmentId/shopper-profiles"

	payload := strings.NewReader("[\n  \"string\"\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/segments/segmentId/shopper-profiles")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "[\n  \"string\"\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.bigcommerce.com/stores/store_hash/v3/segments/segmentId/shopper-profiles")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("[\n  \"string\"\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.bigcommerce.com/stores/store_hash/v3/segments/segmentId/shopper-profiles', [
  'body' => '[
  "string"
]',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/segments/segmentId/shopper-profiles");
var request = new RestRequest(Method.POST);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  \"string\"\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = ["string"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/segments/segmentId/shopper-profiles")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```